ADDGEN   CSECT
*        CREATE THE SECOND HALFWORD OF AN RX TYPE INSTRUCTION.
*        NO ARGUMENTS - THE VALUE ARRAY SUBSCRIPT MUST BE IN R1 ON
*        CALL.  LEAVES RESULT IN LOWER HALF OF REGISTER 1, THE NUMBER O
*        HALFWORDS OF CODE PRODUCED IS ALSO PLACED IN REGISTER 0.
*        PROGRAMMED BY T. QUARLES 4/2/81 AS PART OF THE SPICE 2G.2 CODE
*        GENERATION PACKAGE FOR IBM SYSTEM/360, /370 ARCHITECTURE MACHI
         REGEQU
         USING *,R15
         B     START
         DC    AL1(7)
         DC    CL7'ADDGEN '
         ENTRY TRPNUM
         ENTRY REGVAL
START    STM   R14,R12,12(R13)     COMPLETE THE STANDARD ENTRY SEQUENCE
         SLL   R1,3           MULTIPLY SUBSCRIPT BY 8 TO GET BYETE NUMB
         N     R1,=X'00FFFFFF'     CLEAR HIGH ORDER GARBAGE
         SR    R0,R0          CLEAR THE CODE PRODUCED REGISTER
         LR    R2,R1          COPY ADDRESS
         N     R1,=X'00000FFF'     GET DISPLACEMENT PART
         SRA   R2,12          SHIFT PAGE NUMBER TO WHERE WE WANT IT
         BZ    DONE           PAGE ZERO, SO DON'T HAVE ANY WORK TO DO
         L     R6,=X'7FFFFFFF'      GET AN IMPOSSIBLE TRIP NUMBER
         L     R3,=F'10'      GET THE NUMBER OF REGISTERS
         L     R4,=A(REGVAL)  GET POINTER TO THE TABLE OF VALUES
LOOP     C     R2,0(R4)       CHECK FOR A MATCH BETWEEN PAGE NUMBER & T
         BE    FOUND          GOOD - TABLE ENTRY MATCHED, DON'T NEED TO
         C     R6,4(R4)       CHECK IF THIS IS LEAST RECENTLY USED ENTR
         BNH   NOSWP          NO, SO DON'T SWAP POINTERS
         L     R6,4(R4)       GET THE TRIP NUMBER IN A CONVENIENT REG.
         LR    R7,R4          COPY THE TABLE ENTRY POINTER
         LR    R8,R3          COPY THE REGISTER NUMBER
NOSWP    A     R4,=F'8'       ADD TO POINTER
         BCT   R3,LOOP        SUBTRACT FROM REG
*                                    AND LOOP IF NOT 0.
*        FELL OUT OF THE BOTTOM OF THE LOOP - DIDN'T FIND A VALUE, SO
*        WE MUST PUT THE CORRECT VALUE IN THE DESIRED REGISTER (LRU).
*        CODE PRODUCED TO LOAD THE REGISTER IS
*              LA             R?,PAGENUMBER
*              SLL            R?,12     (MULTIPLY BY 4096 IN A HURRY)
*
         LR    R3,R8          COPY TO THE DESIRED REGISTER SET
         LR    R4,R7
         ST    R2,0(R4)       UPDATA TABLE\
         L     R0,=F'4'       SAY PRODUCED 4 HALFWORDS OF CODE
         L     R9,=V(NXTCOD)  GET PLACE TO PUT CODE
         L     R10,0(R9)      AND THE ACTUAL CODE ADDRESS
         LR    R11,R10        COPY TO ANOTHER REGISTER ALSO
         A     R10,=F'8'      ADD LENGTH OF THE CODE TO IT
         ST    R10,0(R9)      AND PUT BACK FOR THE REST OF THE WORLD
         L     R10,LAINST     GET THE LOAD ADDRESS INSTRUCTION
         SLL   R8,20          SHIFT THE REGISTER NUMBER TO THE DESIRED
         OR    R10,R8         AND PUT THE REGISTER NUMBER IN LA INST
         OR    R10,R2         AND NOW PUT IN THE PAGE NUMBER
         STH   R10,2(R11)     AND PUT OUT AS CODE
         SRL   R10,16
         STH   R10,0(R11)
         L     R10,SLLINST    NOW GET THE SLL INSTRUCTION
         OR    R10,R8         AND PUT THE REGISTER NUMBER IN IT TOO.
         STH   R10,6(R11)     AND PUT OUT AS CODE ALSO
         SRL   R10,16
         STH   R10,4(R11)
FOUND    SLL   R3,12          SHIFT REGISTER TO DESIRED LOCATION
         OR    R1,R3          PUT REGISTER TOGETHER WITH THE DISPLACEME
         L     R7,TRPNUM      GET THE TRIP COUNT
         LA    R7,1(R7)       INCREMENT IT
         ST    R7,TRPNUM      SAVE
         ST    R7,4(R4)       AND PUT IN TABLE FOR LRU ALG. TO FIND
DONE     LM    R2,R12,28(R13) RESTORE ALL USED REGISTERS EXCEPT RETURNS
         BR    R14            AND RETURN TO CALLER
LAINST   LA    R0,0(R0)       THE SAMPLE LOAD ADDRESS INSTRUCTIN
SLLINST  SLL   R0,12          THE SAMPLE SHIFT LEFT LOGICAL INSTRUCTION
REGVAL   DC    20F'-1'        THE INITIAL REGISTER USE TABLE
TRPNUM   DC    F'0'           THE COUNT OF NUMBER OF TIMES THIS ROUTINE
         LTORG
         DROP
         EJECT
SECOND   CSECT
         BC 15,12(15)
         DC X'7'
         DC CL7'SECOND '
         STM  14,12,12(13)
         BALR 12,0
         USING *,12
         L   2,0(,1)
         LA    3,AREA
         DC    X'8330000C'    DIAGNOSE INSTRUCTION FOR TIME INFO
         L     4,16(3)
         N     4,=X'00FFFFFF'
         O     4,=X'4E000000'
         ST    4,16(3)
         LD    0,16(3)
         DD    0,=D'1000000.0'
         STD   0,0(2)
         LM  14,12,12(13)
         MVI 12(13),X'FF'
         BCR 15,14
AREA     DS    4D
         LTORG
         DROP
         EJECT
CODEXC   CSECT
***********************************************************************
*
*
*        CODEXC(NODPLC(LV1),VALUE(LVN)):
*        ASSEMBLER SUBROUTINE TO CAUSE EXECUTION OF THE CODE GENERATED
*        BY CALLS TO THE MINS?  ROUTINES.  FIRST ARGUMENT IS A POINTER
*        TO THE CODE TO EXECUTE, AND THE SECOND IS A POINTER TO THE
*        FIRST ELEMENT OF THE VALUE SUBARRAY.
*
*
*        WRITTEN BY TOM QUARLES 4/1/81 AS PART OF THE MACHINE CODE
*        GENERATION PACKAGE FOR IBM S/360 AND S/370 MACHINES FOR SPICE
*        2G.2
*
**********************************************************************
         USING *,R15          A FAIRLY STANDARD ENTRY SEQUENCE
         B     NAME
         DC    AL1(7)
         DC    CL7'CODEXC'
         ENTRY SCRTCH
         ENTRY NXTCOD
NAME     STM   R14,R12,12(R13)     SAVE REGISTERS
         LA    R3,AREAEX
         ST    R3,8(R13)
         ST    R13,4(R3)
         LR    R0,R13        ACTIVATE NEW SAVE AREA
         LR    R9,R15         SWITCH TO UNUSUAL BASE REGISTER
         DROP  R15
         USING CODEXC,R9
         L     R15,=A(SCRTCH)
         L     R11,4(R1)      GET DATA ADDRESS
         L     R12,16(R15)    PICK UP PIVTOL ADDR
         LD    R4,0(R12)      AND PIVTOL ITSELF
         L     R12,12(R15)    IGOOF ADDR
         L     R12,0(R12)     AND IGOOF ITSELF
         L     R5,0(R1)       R5=ADDR OF CODE TO EXEC.
         BR    R5             SO GO DO IT
AREAEX   DS    18F
NXTCOD   DS    F
SCRTCH   DS    1D             SCRATCH SPACE
         STD   F0,0(R13)      OBJECT OF EXECUTE INSTRUCTION
         DS    2F             MORE SCRATCH SPACE OF A DIFF. TYPE
         LTORG
         DROP
         EJECT
DATIME  CSECT
        BC 15,12(15)
        DC X'7'
        DC CL7'DATIME '
        STM 14,12,12(13)
        BALR 12,0
        USING *,12
        LA 6,SOURCE
        L  7,0(1)
        L  8,4(1)
        DC X'83',XL3'60000C'
        MVC 0(8,7),SOURCE
        MVC 0(8,8),SOURCE+8
        LM  14,12,12(13)
        MVI 12(13),X'FF'
        BCR 15,14
SOURCE  DS  4D
         LTORG
         DROP
         EJECT
MINS3A    CSECT
***********************************************************************
*
*     MINS3A(X,Z):
*
*FUNCTIN TO PROVIDE MACHINE CODE FOR A MINS3A OPERATION.  THE CODE
*PRODUCED IS EQUIVALENT TO  VALUE(X)=VALUE(X)-VALUE(Y)*VALUE(Z) WERE
* Y IS ASSUMED TO BE LEFT IF FPR2 FROM A PREVIOUS OPERATION(MINS2),
* AND X AND Z ARE THE TWO PARAMETERS.  THE RETURN VALUE IS
*THE NUMBER OF HALFWORDS OF CODE PRODUCED.
*
*        PROGRAMMED BY T. QUARLES 4/9/81 AS PART OF THE SPICE 2G.2
* CODE GENERATION PACKAGE FOR IBM SYSTEM/360 /370 ARCHITECTURE MACHINES
*
*
*
***********************************************************************
         USING *,R15
         B     S3A           STANDARD HEADER AND ENTRY SEQUENCE
         DC    AL1(7)
         DC    CL7'MINS3A'
S3A      STM   R14,R12,12(R13)
         DROP  R15
         USING MINS3A,R12
         LR    R12,R15
         LA    R3,AREA3A
         ST    R3,8(R13)
         ST    R13,4(R3)
         LR    R13,R3
         L     R11,=V(NXTCOD) GET ADDRESS OF CODE POINTER
         L     R3,0(R1)       GET FIRST PRAMETER ADDRESS
         L     R5,4(R1)       GET SECOND PARAMETER ADDRESS
         L     R1,0(R3)       GET FIRST ADDRESS
         L     R15,=V(ADDGEN) TRANSLATE TO RX FORM OF ADDRESS
         BALR  R14,R15
         LR    R3,R1          SAVE RESULT
         LR    R6,R0          SAVE AMT. OF CODE PRODUCED
         L     R1,0(R5)       REPEAT FOR SECOND PARAMETER
         L     R15,=V(ADDGEN)
         BALR  R14,R15
         LR    R5,R1
         AR    R6,R0
         A     R6,=F'8'       ADD NUMBER OF 1/2 WORDS WE WILL PRODUCE
         L     R10,0(R11)     GET CODE DEST. ADDRESS
         LH    R9,LD6INST     GET THE LD R6, INSTRUCTIN
         STH   R9,0(R10)      AND OUTPUT
         STH   R5,2(R10)      WITH AN ADDRESS INSERTED
         LH    R8,MDRINST      GET A MDR INSTRUCTION
         STH   R8,4(R10)      OUTPUT
         LH    R9,LD0INST     GET A LD R0,   INSTRUCTION
         STH   R9,6(R10)      OUTPT
         STH   R3,8(R10)     WITH AN ADDRESS FIELD
         LH    R9,SDRINST     GET AN SDR INSTRUCTION
         STH   R9,10(R10)     AND OUTPUT
         LH    R9,STDINST     GET A STD INSTRUCTION
         STH   R9,12(R10)     AND WRITE OUT
         STH   R3,14(R10)     WITH THE FINAL ADDRESS
         A     R10,=F'16'     ADD THE CODE SPACE WE USED TO ADDRESS
         ST    R10,0(R11)     AND PUT ADDRESS BACK WHERE WE FOUND IT
         LR    R0,R6          COPY 1/2 WORDS USED COUNT TO RETURN REG.
         L     R13,4(R13)     GET OLD SAVE AREA POINTER
         LM    R14,R15,12(R13) RECOVER SAVED REGISTERS
         LM    R1,R12,24(R13)     ... CONTINUED ...
         BR    R14            AND RETURN
***********************************************************************
*
*
*
*              CONSTANTS AND DATA AREAS
*
AREA3A   DS    18F
******************************************************
*
*        CODE PRODUCED
*
LD6INST  LD    F6,11(R11,R11)       F6=Z
MDRINST  MDR   F6,F2          F6=Y*Z
LD0INST  LD    F0,11(R11,R11)       F0=X
SDRINST  SDR   F0,F6          F0=X-Y*Z
STDINST  STD   F0,11(R11,R11)       X=X-Y*Z
         LTORG
         DROP
         EJECT
LOC      CSECT
*        I = LOC (X)
         SPACE 2
         USING *,15
         L     0,0(0,1)
         N     0,MASK
         SR    15,15
         BR    14
         SPACE 2
         DS    F
MASK     DC    X'00FFFFFF'
         LTORG
         DROP
         EJECT
MINS0    CSECT
**********************************************************************
*
*        MINS0(PIVTOL,IGOOF,NODPLC(LV1))
*
*        FORTRAN CALLABLE FUNCTION TO PERFORM INITIALIZATION FOR THE
*        MACHINE CODE GENERATION PACKAGE FOR SPICE 2G.2 ON THE IBM
*        SYSTEM/360 /370 ARCHITECTURE MACHINES.
*
*        WRITTEN BY T. QUARLES   5/1/81
**********************************************************************
         USING *,R15
         B     S0           USE A STANDARD HEADER AND ENTRY SEQUENCE
         DC    AL1(5)
         DC    CL5'MINS0'
S0       STM   R14,R12,12(R13)
         LA    R3,AREA0
         ST    R13,4(R3)
         ST    R3,8(R13)
         LR    R13,R3
         LR    R12,R15
         DROP  R15
         USING MINS0,R12
         L     R3,0(R1)       ADDR OF PIVTOL
         L     R4,4(R1)       ADDR OF IGOOF
         L     R5,8(R1)       ADDR OF WHERE TO PUT CODE
         L     R6,=V(SCRTCH)  ADDR OF SCRATCH AREA
         ST    R4,12(R6)      SAVE IGOOF ADDR FOR LATER REF. (CODEXC)
         ST    R3,16(R6)      SAVE PIVTOL ADDR FOR LATER REF.(CODEXC)
         L     R6,=V(NXTCOD)
         ST    R5,0(R6)       REMEMBER WHERE TO PUT CODE
         L     R6,=V(TRPNUM)  AND SET NUMBER OF TRIPS THROUGH ADDR. FCT
         XR    R5,R5          TO 0  XR CLEARS REGISTER 5
         ST    R5,0(R6)
         L     R6,=V(REGVAL)  CLEAR REGVAL ARRAY TO -1
         L     R5,=F'-1'
         ST    R5,0(R6)       PUT IN TABLE
         MVC   4(76,R6),0(R6) AND PROPAGATE THROUGH NEXT 76 BYTES(19 WD
         L     R13,4(R13)     STANDARD EXIT SEQUENCE
         LM    R14,R12,12(R13)
         XR    R0,R0
         XR    R15,R15
         MVI   12(R13),X'FF'
         BR    R14
AREA0    DS    18F
         LTORG
         DROP
         EJECT
MINS1    CSECT
**********************************************************************
*        MINS1(X): IBM ASSEMBLER ROUTINE (FORTRAN CALLABLE) TO GENERATE
*        THE MACHINE CODE TO PERFORM A MINS1 OPERATION:
*        CODE GENERATED IS EQUIVALENT TO
*              IF(ABS(X).GE.PIVTOL) GO TO 10
*              X=PIVTOL
*              IGOOF=IGOOF+1
*           10 CONTINUE
*
*        WRITTEN BY T. QUARLES  4/30/81
**********************************************************************
         USING  *,R15    STANDARD HEADER AND ENTRY SEQUENCE CODE
         B     S1
         DC    AL1(5)
         DC    CL5'MINS1'
S1       STM   R14,R12,12(R13)
         LR    R12,R15
         DROP  R15
         USING MINS1,R12
         LA    R3,AREA1
         ST    R3,8(R13)
         ST    R13,4(R3)
         LR    R13,R3
         L     R1,0(R1)     GET PARAMETER
         L     R1,0(R1)
         L     R15,=V(ADDGEN)       GET CONVERTED TO RX STYLE ADDRESS
         BALR  R14,R15
         LR    R3,R1       SAVE RESULT
         L     R9,=V(NXTCOD)         FIND WHERE TO PUT CODE
         L     R10,0(R9)
         LH    R5,LDINST     MOVE 1ST INSTRUCTION & PUT IN ADDR.
         STH   R5,0(R10)
         STH   R3,2(R10)
         MVC   4(22,R10),LDRINST   MOVE BLOCK OF FIXED INSTRUCTIONS
         LH    R5,LAINST1      PUT IN LAST TWO INSTRUCTIONS
         STH   R5,26(R10)
         STH   R3,28(R10)
         MVC   30(4,R10),EXINST
         A     R10,=F'34'          ADD NUMBER OF BYTES USED
         A     R0,=F'17'    RETURN NUMBER OF HALF WORDS USED
         ST    R10,0(R9)
         L     R13,4(R13)    NORMAL RETURN SEQUENCE
         LM    R14,R15,12(R13)
         LM    R1,12,24(R13)
         XR    R15,R15
         MVI   12(R13),X'FF'
         BR    R14
AREA1    DS    18F        SAVE AREA
****************************************************************
*
*        CODE PRODUCED
*
****************************************************************
LDINST   LD    F0,11(R11,R11)      2ND OP IS X
LDRINST  LPDR  F6,F0
         SDR   F6,F4
         STD   F6,0(R15)
         L     R14,0(R15)
         SRL   R14,31
         AR    R12,R14
         SLL   R14,6
LAINST1  LA    R13,11(R11,R11)     2ND OP IS X
EXINST   EX    R14,8(R15)
         LTORG
         DROP
         EJECT
MINS2    CSECT
********************************************************************
*
*        MINS2(X,Y):
*              FUNCTION TO PRODUCE MACHINE CODE FOR A MINS2 OPERATION.
*        THE CODE PRODUCED IS EQUIVALENT TO VALUE(X)=VALUE(X)/VALUE(Y),
*        THE RETURN VALUE OF THE CALL IS THE NUMBERJOF HALF WORDS USED
*        FOR THE CODE PRODUCED.
*        LEAVES RESULT IN FPR 2 IN ADDITION TO STORING IN PROPER PLACE
*        IN VALUE.
*
*
*        WRITTEN BY TOM QUARLES  5/1/81 AS PART OF THE IBM S/360 AND
*        S/370 CODE GENERATION PACKAGE FOR SPICE 2G.2
******************************************************************
         USING *,R15
         B     S2        USE A STANDARD ENTRY SEQUENCE AND HEADER
         DC    AL1(5)
         DC    CL5'MINS2'
S2       STM   14,12,12(R13)
         DROP  R15
         USING MINS2,R12
         LR    R12,R15        SWITCH TO ANOTHER BASE REGISTER
         LA    R3,AREA2
         ST    R3,8(R13)
         ST    R13,4(R3)
         LR    R13,R3
         L     R11,=V(NXTCOD) GET ADDRESS OF ADDRESS WHERE CODE GOES
         L     R3,0(R1)       GET ADDRESS OF FIRST PARAMETER
         L     R4,4(R1)       GET ADDRESS OF SECOND PARAMETER
         L     R1,0(R3)
         L     R15,=V(ADDGEN)     AND GET IT TRANSLATED TO RX FORM
         BALR  R14,R15
         LR    R3,R1          SAVE THE RESULTING HALFWORD
         LR    R6,R0          SAVE SPACE USED TO SET UP BASE REGISTERS
         L     R1,0(R4)       REPEAT ABOVE FOR SECOND PARAMETER
         L     R15,=V(ADDGEN)
         BALR  R14,R15
         LR    R4,R1
         AR    R6,R0
         L     R10,0(R11)     GET ADDRESS FOR NEXT CODE
         LH    R9,LDINST2     GET THE LOAD DOUBLE INSTRUCTION
         STH   R9,0(R10)      AND PUT OUT AS PART OF THE CODE
         STH   R3,2(R10)      AND PUT AN ADDRESS IN IT
         LH    R9,DDINST      GET A DIVIDE DOUBLE INSTRUCTION
         STH   R9,4(R10)      AND GENERATE IT AS CODE
         STH   R4,6(R10)      WITH AN APPROPRIATE ADDRESS
         LH    R9,STDINST2    GET A STORE DOUBLE INSTRUCTION
         STH   R9,8(R10)      GENERATE IT AS CODE
         STH   R3,10(R10)     WITH AN ADDRESS
         A     R10,=F'12'     NEED TO UPDATE THE NEXT INSTRUCTION ADDRE
         ST    R10,0(R11)     AND PUT IT BACK WHERE WE FOUND IT
         A     R6,=F'6'       AND GENERATE THE HALFWORDS PRODUCED COUNT
         LR    R0,R6          AND PUT IT IN THE RIGHT REGISTER
         L     R13,4(R13)     GET BACK SAVE AREA POINTER
         LM    R14,R15,12(R13) RECOVER CALLER'S REG. SET
         LM    R1,R12,24(R13) CONTINUED...
         BR    R14            AD RETURN TO CALLER
******************************************************************
*
*
*
*
*        CONSTANTS AND DATA STORAGE AREAS
*
*
AREA2    DS    18F            SAVE AREA
*********************************************************************
*
*        CODE PRODUCED
*
LDINST2  LD    F2,11(R11,R11)       FAKE LOAD DOUBLE INSTRUCTION
DDINST   DD    F2,11(R11,R11)       FAKE DIVIDED DOUBLE INSTRUCTION
STDINST2 STD   F2,11(R11,R11)       FAKE STORE DOUBLE INSTRUCTION
*
*
*
         LTORG
         DROP
         EJECT
MINS4    CSECT
*********************************************************************
*        MINS4: ASSEMBLER SUBROUTINE TO GENERATE MACHINE CODE FOR
*        A MINS4 OPERATION.
*        FORTRAN CALLABLE!
*        PRODUCES CODE TO TERMINATE MINS SEQUENCE BY RESTORING IGOOF TO
*        MEMORY, PERFORMING CLEAN UP AND RETURNING TO THE CALLER OF
*        CODEXC
*
*        WRITTEN BY T. QUARLES    4/30/81
*********************************************************************
         USING *,R15
         B     S4          STANDARD HEADER AND ENTRY SEQUENCE
         DC    AL1(5)
         DC    CL5'MINS4'
S4       STM   R14,R12,12(R13)
         LR    R12,R15
         DROP  R15
         USING MINS4,R12
         LA    R3,AREA4
         ST    R3,8(R13)
         ST    R13,4(R3)
         LR    R13,R3
         L     R9,=V(NXTCOD)       FIND OUT WHERE TO PUT CODE
         L     R10,0(R9)
         MVC   0(22,R10),CODE       MOVE CODE IN
         A     R10,=F'22'           UPDATE WHERE TO PUT CODE POINTER
         ST    R10,0(R9)
         L     R0,=F'11'
         L     R13,4(R13)           RETURN SEQUENCE
         LM    R1,R12,24(R13)
         MVI   12(R13),X'FF'
         XR    R15,R15
         BR    R14
***********************************************************************
*
*
*
*        CONSTANTS AND DATA AREAS
*
*
AREA4    DS    18F
***********************************************************************
*
*
*        CODE PRODUCED
*
CODE     L     R10,12(R15)       RECOVER IGOOF ADDRESS
         ST    R12,0(R10)        SAVE IGOOF
         LR    R13,R0            RESTORE SAVE AREA POINTER
         LM    R14,R12,12(R13)   RESTORE REGS.
         XR    R15,R15           SAY DONE
         MVI   12(R13),X'FF'     SAY DONE
         BR    R14               AND LEAVE
         LTORG
         DROP
         EJECT
MINS3    CSECT
***********************************************************************
*
*   MINS3(X,Y,Z):
*
*FUNCTIN TO PROVIDE MACHINE CODE FOR A MINS3 OPERATION.  THE CODE
*PRODUCED IS EQUIVALENT TO  VALUE(X)+VALUE(X)-VALUE(Y)*VALUE(Z) WERE
*THE SUBSCRIPTS X,Y,Z ARE THE THREE PARAMETERS.  THE RETURN VALUE IS
*THE NUMBER OF HALFWORDS OF CODE PRODUCED.
*
*        PROGRAMMED BY T. QUARLES 4/9/81 AS PART OF THE SPICE 2G.2
* CODE GENERATION PACKAGE FOR IBM SYSTEM/360 /370 ARCHITECTURE MACHINES
*
*
*
***********************************************************************
         USING *,R15
         B     S3       STANDARD HEADER AND ENTRY SEQUENCE
         DC    AL1(5)
         DC    CL5'MINS3'
S3       STM   R14,R12,12(R13)
         DROP  R15
         USING MINS3,R12
         LR    R12,R15
         LA    R3,AREA3
         ST    R3,8(R13)
         ST    R13,4(R3)
         LR    R13,R3
         L     R11,=V(NXTCOD) GET ADDRESS OF CODE POINTER
         L     R3,0(R1)       GET FIRST PRAMETER ADDRESS
         L     R4,4(R1)       GET SECOND PARAMETER ADDRESS
         L     R5,8(R1)       GET THIRD PARAMETER ADDRESS
         L     R1,0(R3)       GET FIRST ADDRESS
         L     R15,=V(ADDGEN) TRANSLATE TO RX FORM OF ADDRESS
         BALR  R14,R15
         LR    R3,R1          SAVE RESULT
         LR    R6,R0          SAVE AMT. OF CODE PRODUCED
         L     R1,0(R4)       REPEAT FOR SECOND PARAMETER
         L     R15,=V(ADDGEN)
         BALR  R14,R15
         LR    R4,R1
         AR    R6,R0
         L     R1,0(R5)       AND AGAIN FOR THE THIRD PARAMETER
         L     R15,=V(ADDGEN)
         BALR  R14,R15
         LR    R5,R1
         AR    R6,R0
         A     R6,=F'9'       ADD NUMBER OF 1/2 WORDS WE WILL PRODUCE
         L     R10,0(R11)     GET CODE DEST. ADDRESS
         LH    R9,LD6INST3    GET THE LD R6, INSTRUCTIN
         STH   R9,0(R10)      AND OUTPUT
         STH   R5,2(R10)      WITH AN ADDRESS INSERTED
         LH    R8,MDINST      GET A MD INSTRUCTION
         STH   R8,4(R10)      OUTPUT
         STH   R4,6(R10)      WITH AN ADDRESS
         LH    R9,LD0INST3    GET A LD R0,   INSTRUCTION
         STH   R9,8(R10)      OUTPT
         STH   R3,10(R10)     WITH AN ADDRESS FIELD
         LH    R9,SDRINST3    GET AN SDR INSTRUCTION
         STH   R9,12(R10)     AND OUTPUT
         LH    R9,STDINST3    GET A STD INSTRUCTION
         STH   R9,14(R10)     AND WRITE OUT
         STH   R3,16(R10)     WITH THE FINAL ADDRESS
         A     R10,=F'18'     ADD THE CODE SPACE WE USED TO ADDRESS
         ST    R10,0(R11)     AND PUT ADDRESS BACK WHERE WE FOUND IT
         LR    R0,R6          COPY 1/2 WORDS USED COUNT TO RETURN REG.
         L     R13,4(R13)     GET OLD SAVE AREA POINTER
         LM    R14,R15,12(R13) RECOVER SAVED REGISTERS
         LM    R1,R12,24(R13)     ... CONTINUED ...
         BR    R14            AND RETURN
***********************************************************************
*
*
*
*              CONSTANTS AND DATA AREAS
*
AREA3    DS    18F
**************************************************************
*
*        CODE PRODUCED
*
LD6INST3 LD    F6,11(R11,R11)       F6=Z
MDINST   MD    F6,11(R11,R11)       F6=Y*Z
LD0INST3 LD    F0,11(R11,R11)       F0=X
SDRINST3 SDR   F0,F6          F0=X-Y*Z
STDINST3 STD   F0,11(R11,R11)       X=X-Y*Z
         LTORG
         DROP
         EJECT
GTMAIN   CSECT
******************************************************************
*
*        GTMAIN(KFAMWA,MAXMEM)
*
*        RETURNS KFAMWA=ADDRESS OF FIRST AVAILABLE WORD OF GETMAIN
*        FREE STORAGE, MAXMEM=NUMBER OF WORDS AVAILABLE FOR USE
*
******************************************************************
         USING *,R15
         B     GMN
         DC    AL1(7)
         DC    CL7'GTMAIN'
GMN      STM   R14,R12,12(R13)
         LA    R3,MAREA       STANDARD ENTRY SEQUENCE FOR ROUTINE
         ST    R13,4(R3)
         ST    R3,8(R13)
         LR    R13,R3
         LR    R12,R15
         LR    R9,R1          SAVE PARM POINTER
         DROP  R15
         USING GTMAIN,R12
         GETMAIN              VC,LA=SIZE,A=WHERE1
         L     R10,WHERE1+4   GET SIZE OF SPACE AVAILABLE
         FREEMAIN V,A=WHERE1    RETURN THE SPACE TO CMS
         S     R10,=F'32768'  LOP OFF A CHUNK FOR THE O/S TO PLAY WITH
         BNP   NOSPACE        SINCE NOT ENOUGH ROOM LEFT FOR SYSTEM, CA
         ST    R10,SIZE+4     PUT IN AS NEW MAX. NUM. BYTES
         GETMAIN VC,LA=SIZE,A=WHERE1    AND ASK AGAIN.
         LTR   R9,R9          CHECK IF PARMS SUPPLIED
         BZ    NOPARM
         L     R6,0(R9)       GET ADDR OF KFAMWA
         CLI   0(R9),X'FF'    CHECK FOR SECOND PARM
         BZ    NOPARM
         L     R7,4(R9)       GET ADDR OF MAXMEM
         L     R4,WHERE1      GET LOCATION OF AREA
         SRL   R4,2           DIVIDE BY 2 TO GET ADDRESS IN WORDS
         ST    R4,0(R6)       PUT IN KFAMWA
         L     R4,WHERE1+4    GET SIZE OF AREA
         SRL   R4,2           DIVIDE BY 4 TO GET SIZE IN WORDS
         ST    R4,0(R7)       PUT IN MAXMEM
NRET     L     R13,4(R13)
         LM    R14,R12,12(R13)     STANDARD RETURN SEQUENCE
         MVI   12(R13),X'FF'
         XR    R15,R15
         BR    R14
NOSPACE  NOPR  R0
NOPARM   L     R13,4(R13)
         LM    R14,R12,12(R13)     ERROR RETURN SEQUENCE
         LA    R15,4095
         BR    R14
MAREA    DS    18F
SIZE     DC    F'8'
         DC    X'00FFFFF8'
WHERE1   DS    2F
         LTORG
         DROP
         END
